﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace ExtensionMethodsExample
{
    public static class Extensions
    {
        public static List<T> RemoveDuplicates<T>(this List<T> input)
        {
            Dictionary<T, int> uniqueStore = new Dictionary<T, int>();
            List<T> finalList = new List<T>();

            foreach (T currValue in input)
            {
                if (!uniqueStore.ContainsKey(currValue))
                {
                    uniqueStore.Add(currValue, 0);
                    finalList.Add(currValue);
                }
            }
            return finalList;
        }
    }

    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            // Required to initialize variables
            InitializeComponent();

            List<string> input = new List<string>();
            input.Add("There");
            input.Add("Here");
            input.Add("Sneer");
            input.Add("There");
            input.Add("Near");
            input.Add("Meer");
            input.Add("Here");

            List<string> result = input.RemoveDuplicates();
        }
    }
}